"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ArrayMember = void 0;
const common_errors_1 = require("common-errors");
const storage_1 = require("../storage");
/* eslint-disable @typescript-eslint/no-non-null-assertion */
function ArrayMember(index, options) {
    if (typeof (index) !== 'number') {
        throw new common_errors_1.TypeError('index must be number');
    }
    return (target, propertyKey) => {
        // eslint-disable-next-line @typescript-eslint/ban-types
        if (!storage_1.storage.has(target.constructor)) {
            storage_1.storage.set(target.constructor, new Map());
        }
        const map = storage_1.storage.get(target.constructor);
        map.set(index, new storage_1.PropertyInfo(propertyKey, options));
        storage_1.storage.set(target.constructor, new Map([...map.entries()].sort((a, b) => a[0] - b[0])));
    };
}
exports.ArrayMember = ArrayMember;
//# sourceMappingURL=ArrayMember.js.map