"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.arrayTransformAndValidates = exports.arrayTransformAndValidate = exports.classToPlainArray = exports.classMapValue = exports.plainArrayToClasses = exports.plainArrayToClass = exports.plainMapValue = void 0;
/* eslint-disable @typescript-eslint/no-explicit-any */
const class_transformer_1 = require("class-transformer");
const class_transformer_validator_1 = require("class-transformer-validator");
const storage_1 = require("class-transformer/storage");
const common_errors_1 = require("common-errors");
const exceptions_1 = require("./exceptions");
const storage_2 = require("./storage");
__exportStar(require("./decorators/ArrayMember"), exports);
__exportStar(require("./storage"), exports);
__exportStar(require("./exceptions"), exports);
__exportStar(require("./types"), exports);
function plainMapValue(target, array) {
    var _a;
    const map = storage_2.storage.get(target);
    if (!map) {
        throw new exceptions_1.UnknownClassError(`Cannot found class of ${target.name}`);
    }
    const obj = {};
    for (const [i, o] of array.entries()) {
        const property = map.get(i);
        if (property) {
            const typeMeta = storage_1.defaultMetadataStorage.findTypeMetadata(target, property.key);
            const subTarget = typeMeta === null || typeMeta === void 0 ? void 0 : typeMeta.typeFunction();
            if (storage_2.storage.has(subTarget)) {
                if (Array.isArray(o)) {
                    if ((typeMeta === null || typeMeta === void 0 ? void 0 : typeMeta.reflectedType) === Array || ((_a = property.options) === null || _a === void 0 ? void 0 : _a.isArray)) {
                        obj[property.key] = o.map((p) => plainMapValue(subTarget, p));
                    }
                    else {
                        obj[property.key] = plainMapValue(subTarget, o);
                    }
                }
                else {
                    obj[property.key] = o;
                }
            }
            else {
                obj[property.key] = o;
            }
        }
    }
    return obj;
}
exports.plainMapValue = plainMapValue;
function plainArrayToClass(target, array, options) {
    return class_transformer_1.plainToClass(target, plainMapValue(target, array), options);
}
exports.plainArrayToClass = plainArrayToClass;
function plainArrayToClasses(target, array, options) {
    return class_transformer_1.plainToClass(target, array.map((arr) => plainMapValue(target, arr)), options);
}
exports.plainArrayToClasses = plainArrayToClasses;
function classMapValue(target, object) {
    var _a;
    const map = storage_2.storage.get(target);
    if (!map) {
        throw new exceptions_1.UnknownClassError(`Cannot found class of ${target.name}`);
    }
    const arr = [];
    for (const [i, property] of map.entries()) {
        if (property.key in object) {
            const typeMeta = storage_1.defaultMetadataStorage.findTypeMetadata(target, property.key);
            const subTarget = typeMeta === null || typeMeta === void 0 ? void 0 : typeMeta.typeFunction();
            if (storage_2.storage.has(subTarget)) {
                if ((typeMeta === null || typeMeta === void 0 ? void 0 : typeMeta.reflectedType) === Array || ((_a = property.options) === null || _a === void 0 ? void 0 : _a.isArray)) {
                    if (object[property.key] == null) {
                        arr[i] = object[property.key];
                    }
                    else {
                        if (!Array.isArray(object[property.key])) {
                            throw new common_errors_1.TypeError(`property ${target.name}.${property.key} is not an array: ${object[property.key]}`);
                        }
                        arr[i] = object[property.key].map((p) => classMapValue(subTarget, p));
                    }
                }
                else {
                    arr[i] = classMapValue(subTarget, object[property.key]);
                }
            }
            else {
                arr[i] = object[property.key];
            }
        }
        else {
            arr[i] = undefined;
        }
    }
    return arr;
}
exports.classMapValue = classMapValue;
function classToPlainArray(object, options) {
    if (Array.isArray(object) && !object.length) {
        return [];
    }
    const record = class_transformer_1.classToPlain(object, options);
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    const c = Array.isArray(object) ? object[0].constructor : object.constructor;
    if (Array.isArray(object)) {
        return record.map((o) => classMapValue(c, o));
    }
    else {
        return classMapValue(c, record);
    }
}
exports.classToPlainArray = classToPlainArray;
// eslint-disable-next-line @typescript-eslint/ban-types
function arrayTransformAndValidate(target, array, options) {
    return class_transformer_validator_1.transformAndValidate(target, plainMapValue(target, array), options);
}
exports.arrayTransformAndValidate = arrayTransformAndValidate;
// eslint-disable-next-line @typescript-eslint/ban-types
function arrayTransformAndValidates(target, array, options) {
    return class_transformer_validator_1.transformAndValidate(target, array.map((arr) => plainMapValue(target, arr)), options);
}
exports.arrayTransformAndValidates = arrayTransformAndValidates;
//# sourceMappingURL=index.js.map