"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const src_1 = require("../src");
const Product_1 = require("./classes/Product");
let ArrayTransformAndValidatesTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class ArrayTransformAndValidatesTest {
    async normal() {
        var _a, _b;
        const expected = [
            [1, ['blue'], 2.2, '2'],
            [2, ['yellow'], 2.2, '2'],
        ];
        const results = await src_1.arrayTransformAndValidates(Product_1.Product, expected);
        {
            const row = expected[0];
            const result = results[0];
            // basic
            chai_1.expect(result.constructor).equals(Product_1.Product);
            chai_1.expect(result).property('id', row[0]);
            // nested
            chai_1.expect(result).property('color').not.null;
            chai_1.expect((_a = result.color) === null || _a === void 0 ? void 0 : _a.constructor).equals(Product_1.Color);
            chai_1.expect(result).property('color').property('name', row[1][0]);
            // test class-transform
            chai_1.expect(result).property('price', +(+row[2]).toFixed());
        }
        {
            const row = expected[1];
            const result = results[1];
            // basic
            chai_1.expect(result.constructor).equals(Product_1.Product);
            chai_1.expect(result).property('id', row[0]);
            // nested
            chai_1.expect(result).property('color').not.null;
            chai_1.expect((_b = result.color) === null || _b === void 0 ? void 0 : _b.constructor).equals(Product_1.Color);
            chai_1.expect(result).property('color').property('name', row[1][0]);
            // test class-transform
            chai_1.expect(result).property('price', +(+row[2]).toFixed());
        }
    }
    async fail() {
        const expected = [
            [1, ['blue'], 2.2, 0],
            [2, ['yellow'], 2.2, 0],
        ];
        await chai_1.expect(src_1.arrayTransformAndValidates(Product_1.Product, expected)).to.eventually.be.rejected;
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidatesTest.prototype, "normal", null);
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ArrayTransformAndValidatesTest.prototype, "fail", null);
ArrayTransformAndValidatesTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], ArrayTransformAndValidatesTest);
//# sourceMappingURL=arrayTransformAndValidates.test.js.map