"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable @typescript-eslint/no-explicit-any */
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const src_1 = require("../src");
const Product_1 = require("./classes/Product");
let ClassMapValueTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class ClassMapValueTest {
    async normal() {
        var _a, _b;
        const expected = { "id": 1, "price": 2, "displayPrice": "2", "sizes": [{ "size": 1 }, { "size": 2 }], "color": { "name": "blue" }, "values": [1, 2] };
        const result = src_1.classMapValue(Product_1.Product, expected);
        // basic
        chai_1.expect(result.constructor).equals(Array);
        chai_1.expect(result).property('0', expected.id);
        // nested
        chai_1.expect(result).property('1').not.null;
        chai_1.expect((_a = result[1]) === null || _a === void 0 ? void 0 : _a.constructor).equals(Array);
        chai_1.expect(result).property('1').property('0', (_b = expected.color) === null || _b === void 0 ? void 0 : _b.name);
        // other values
        chai_1.expect(result).property('2', expected.price);
        chai_1.expect(result).property('3', expected.displayPrice);
        chai_1.expect(result[4]).not.null;
        chai_1.expect(result[4].constructor).equal(Array);
        chai_1.expect(result[4]).length(2);
        chai_1.expect(result).property('4').property('0').property('0', expected.sizes[0].size);
        chai_1.expect(result).property('4').property('1').property('0', expected.sizes[1].size);
        chai_1.expect(result[5]).not.null;
        chai_1.expect(result[5].constructor).equal(Array);
        chai_1.expect(result[5]).length(2);
        chai_1.expect(result).property('5').property('0', expected.values[0]);
        chai_1.expect(result).property('5').property('1', expected.values[1]);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], ClassMapValueTest.prototype, "normal", null);
ClassMapValueTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], ClassMapValueTest);
//# sourceMappingURL=classMapValue.test.js.map