"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
const mocha_1 = require("@testdeck/mocha");
const chai_1 = require("chai");
const src_1 = require("../src");
const Product_1 = require("./classes/Product");
let PlainMapValueTest = 
// eslint-disable-next-line @typescript-eslint/no-unused-vars
class PlainMapValueTest {
    async normal() {
        const expected = [1, ['blue'], 2.2, '2', [[1], [2]], [1, 2]];
        const result = src_1.plainMapValue(Product_1.Product, expected);
        // basic
        chai_1.expect(result).property('id', expected[0]);
        // nested
        chai_1.expect(result).property('color').not.null;
        chai_1.expect(result).property('color').property('name', expected[1][0]);
        // test class-transform
        chai_1.expect(result).property('price', expected[2]);
        chai_1.expect(result).property('displayPrice', expected[3]);
        // test array
        chai_1.expect(result.sizes).not.null;
        chai_1.expect(result.sizes).property('constructor').equal(Array);
        chai_1.expect(result.sizes).length(2);
        chai_1.expect(result.sizes).property('0').property('size', expected[4][0][0]);
        chai_1.expect(result.sizes).property('1').property('size', expected[4][1][0]);
        chai_1.expect(result.values).not.null;
        chai_1.expect(result.values).length(2);
        chai_1.expect(result.values).property('0').equal(expected[5][0]);
        chai_1.expect(result.values).property('1').equal(expected[5][1]);
    }
};
__decorate([
    mocha_1.test(),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", Promise)
], PlainMapValueTest.prototype, "normal", null);
PlainMapValueTest = __decorate([
    mocha_1.suite()
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
], PlainMapValueTest);
//# sourceMappingURL=plainMapValue.test.js.map